//This program code is released under GNU General Public License (GPL)
//(http://www.gnu.org/copyleft/gpl.html)
//(C) Wolfgang Gossel (2012)
// Muehlweg 49 
// D-06114 Halle
//or: Martin Luther University
//    Dept. Hydrogeology and Environmental Geology
//    V.-Seckendorff Platz 3
//    D-06120 Halle
//email: wolfgang.gossel@geo.uni-halle.de
//homepage: http://www.mo2geo.org
//
///-----------------------------------------------------------------
///
/// @file      Project2Dlg.h
/// @author    ghe3g
/// Created:   19.07.2012 10:12:26
/// @section   DESCRIPTION
///            Project2Dlg class declaration
///
///------------------------------------------------------------------

#ifndef __PROJECT2DLG_H__
#define __PROJECT2DLG_H__

#ifdef __BORLANDC__
	#pragma hdrstop
#endif

#ifndef WX_PRECOMP
	#include <wx/wx.h>
	#include <wx/dialog.h>
#else
	#include <wx/wxprec.h>
#endif

//Do not add custom headers between 
//Header Include Start and Header Include End.
//wxDev-C++ designer will remove them. Add custom headers after the block.
////Header Include Start
#include <wx/filedlg.h>
#include <wx/bmpbuttn.h>
#include <wx/gauge.h>
#include <wx/button.h>
#include <wx/textctrl.h>
#include <wx/stattext.h>
////Header Include End

////Dialog Style Start
#undef Project2Dlg_STYLE
#define Project2Dlg_STYLE wxCAPTION | wxRESIZE_BORDER | wxSYSTEM_MENU | wxDIALOG_NO_PARENT | wxMINIMIZE_BOX | wxCLOSE_BOX
////Dialog Style End

class Project2Dlg : public wxDialog
{
	private:
		DECLARE_EVENT_TABLE();
		
	public:
		Project2Dlg(wxWindow *parent, wxWindowID id = 1, const wxString &title = wxT("Project2"), const wxPoint& pos = wxDefaultPosition, const wxSize& size = wxDefaultSize, long style = Project2Dlg_STYLE);
		virtual ~Project2Dlg();
		void WxBitmapButtonOpenInputFileClick(wxCommandEvent& event);
		void WxBitmapButtonFileOpenResultClick(wxCommandEvent& event);
		void setInputValues();
	
	private:
		void WxButtonRunClick(wxCommandEvent& event);
		//Do not add custom control declarations between 
		//GUI Control Declaration Start and GUI Control Declaration End.
		//wxDev-C++ will remove them. Add custom code after the block.
		////GUI Control Declaration Start
		wxStaticText *WxStaticTextAtlasBNA;
		wxStaticText *WxStaticTextESRIGRID;
		wxFileDialog *WxOpenFileDialogInputFile;
		wxFileDialog *WxOpenFileDialogResFile;
		wxBitmapButton *WxBitmapButtonFileOpenResult;
		wxBitmapButton *WxBitmapButtonOpenInputFile;
		wxTextCtrl *WxEditResultFileName;
		wxTextCtrl *WxEditInputFileName;
		wxGauge *WxGaugeCalculated;
		wxButton *WxButtonRun;
		wxStaticText *WxStaticTextResFile;
		wxTextCtrl *WxEditRasWidth;
		wxStaticText *WxStaticTextDistRas;
		wxTextCtrl *WxEditXMaxRas;
		wxStaticText *WxStaticTextXMaxRas;
		wxStaticText *WxStaticTextXMax;
		wxStaticText *WxStaticTextXMaxLine;
		wxTextCtrl *WxEditYMaxRas;
		wxStaticText *WxStaticText4;
		wxStaticText *WxStaticTextYMax;
		wxStaticText *WxStaticTextYMaxLines;
		wxTextCtrl *WxEditYMinRas;
		wxStaticText *WxStaticTextYMinRas;
		wxStaticText *WxStaticTextYMin;
		wxStaticText *WxStaticTextYMinLine;
		wxStaticText *WxStaticTextXMinRas;
		wxStaticText *WxStaticTextXMin;
		wxTextCtrl *WxEditXMinRas;
		wxStaticText *WxStaticTextXMinLine;
		wxStaticText *WxStaticTextOpenFile;
		////GUI Control Declaration End
		wxString pathBNAInputFileName, pathEGOutputFileName;
		long number_of_points, altis, number_of_parts, num_ras_pnt;
		double dblMaxX, dblMaxY, dblMinX, dblMinY, alti_dist, distance;
		long *alti_num;
		double *altitude;
		double *longitude_s;
		double *latitude_s;
		double *longitude_e;
		double *latitude_e;
		
		double *raster_lon;
		double *raster_lat;
		double *raster_z;
		
	private:
		//Note: if you receive any error with these enum IDs, then you need to
		//change your old form code that are based on the #define control IDs.
		//#defines may replace a numeric value for the enum names.
		//Try copy and pasting the below block in your old form header files.
		enum
		{
			////GUI Enum Control ID Start
			ID_WXSTATICTEXTATLASBNA = 1052,
			ID_WXSTATICTEXTESRIGRID = 1051,
			ID_WXBITMAPBUTTONFILEOPENRESULT = 1050,
			ID_WXBITMAPBUTTONOPENINPUTFILE = 1049,
			ID_WXEDITRESULTFILENAME = 1048,
			ID_WXEDITINPUTFILENAME = 1047,
			ID_WXGAUGECALCULATED = 1046,
			ID_WXBUTTONRUN = 1045,
			ID_WXSTATICTEXTRESFILE = 1042,
			ID_WXEDITRASWIDTH = 1040,
			ID_WXSTATICTEXTDISTRAS = 1039,
			ID_WXEDITXMAXRAS = 1038,
			ID_WXSTATICTEXTXMAXRAS = 1037,
			ID_WXSTATICTEXTXMAX = 1036,
			ID_WXSTATICTEXTXMAXLINE = 1035,
			ID_WXEDITYMAXRAS = 1028,
			ID_WXSTATICTEXT4 = 1027,
			ID_WXSTATICTEXTYMAX = 1026,
			ID_WXSTATICTEXTYMAXLINES = 1025,
			ID_WXEDITYMINRAS = 1018,
			ID_WXSTATICTEXTYMINRAS = 1017,
			ID_WXSTATICTEXTYMIN = 1016,
			ID_WXSTATICTEXTYMINLINE = 1015,
			ID_WXSTATICTEXTXMINRAS = 1008,
			ID_WXSTATICTEXTXMIN = 1007,
			ID_WXEDITXMINRAS = 1006,
			ID_WXSTATICTEXTXMINLINE = 1004,
			ID_WXSTATICTEXTOPENFILE = 1003,
			////GUI Enum Control ID End
			ID_DUMMY_VALUE_ //don't remove this value unless you have other enum values
		};
	
	private:
		void OnClose(wxCloseEvent& event);
		void CreateGUIControls();
};

#endif
