//This program code is released under GNU General Public License (GPL)
//(http://www.gnu.org/copyleft/gpl.html)
//(C) Wolfgang Gossel (2012)
// Muehlweg 49 
// D-06114 Halle
//or: Martin Luther University
//    Dept. Hydrogeology and Environmental Geology
//    V.-Seckendorff Platz 3
//    D-06120 Halle
//email: wolfgang.gossel@geo.uni-halle.de
//homepage: http://www.mo2geo.org
//
// Class implementation to get the input lines


#include <iostream>
#include <fstream>
#include <string.h>
#include <stdlib.h>
#include "getInput.h"
#include <wx/wx.h>

using namespace std;

void getLines::setFile(wxString wxStrInputFileName)
{
    int a;
    infile=wxStrInputFileName;
}

void getLines::getLinesFromFile()
{
     ifstream fin(infile);
     getline(fin, file_content,'\t');
}

void getLines::analyze_file_content()
{
     long counter1=0, counter_token=0;
     char *token;
     char *temp_total_chars;
     
     const char *total_chars=file_content.c_str();
     temp_total_chars = (char*)total_chars;

     for(counter1=0;counter1<num_points;counter1++)
     {
          token = strtok((char*)temp_total_chars,",");
          x[counter1]=atof(token);
          counter_token=strlen(token)+1;
          temp_total_chars=temp_total_chars+counter_token;
          token = strtok((char*)temp_total_chars,",");
          y[counter1]=atof(token);
          counter_token=strlen(token)+1;
          temp_total_chars=temp_total_chars+counter_token; 
          token = strtok((char*)temp_total_chars,",");
          z[counter1]=atof(token);
          counter_token=strlen(token)+1;
          temp_total_chars=temp_total_chars+counter_token;  
          token = strtok((char*)temp_total_chars,",");
          lin_p[counter1]=atol(token);
          counter_token=strlen(token)+1;
          temp_total_chars=temp_total_chars+counter_token;
          token = strtok((char*)temp_total_chars,"\n");
          pnt_counter[counter1]=atol(token);
          counter_token=strlen(token)+1;
          temp_total_chars=temp_total_chars+counter_token; 
     }
}

void getLines::analyze_file_content_bna()
{
     long counter_pl=0, counter_pt=0, counter_l=0, counterToken=0, numVertices=0, heightLine=0, numberVertices=0;
     char *token;
     char *tempTotalChars;
     maxX=0;
     maxY=0;
     minX=1e10;
     minY=1e10;
     
     const char *total_chars=file_content.c_str();
     tempTotalChars = (char*)total_chars;
     
     for (counter_l=0; counter_l<numLines_bna;counter_l++)
     {
        numVertices=0;
        heightLine=0;
        token = strtok((char*)tempTotalChars,","); //read p_name (not of interest)
        counterToken=strlen(token)+1;
        tempTotalChars=tempTotalChars+counterToken;
        token = strtok((char*)tempTotalChars,"\""); //read to beginning of sname (attribute)
        heightLine=atoi(token);
        counterToken=strlen(token)+3;
        tempTotalChars=tempTotalChars+counterToken;
        token = strtok((char*)tempTotalChars,"\n"); //read number vertices of line
        numVertices=atoi(token);
        numVertices=-numVertices;
    
        numberVertices=numVertices;
        
        counterToken=strlen(token)+1;
        tempTotalChars=tempTotalChars+counterToken;

        for(counter_pl=0;counter_pl<numberVertices;counter_pl++)
        {
          token = strtok((char*)tempTotalChars,",");
          x[counter_pt]=atof(token);
          counterToken=strlen(token)+1;
          tempTotalChars=tempTotalChars+counterToken;
          token = strtok((char*)tempTotalChars,"\n");
          y[counter_pt]=atof(token);
          counterToken=strlen(token)+1;
          tempTotalChars=tempTotalChars+counterToken; 
          z[counter_pt]=heightLine;
          lin_p[counter_pt]=counter_l;
          pnt_counter[counter_pt]=counter_pl;
//          tempStrg<<counter_pt<<"; "<<x[counter_pt]<<"; "<<y[counter_pt]<<"; "<<z[counter_pt]<<"; "<<lin_p[counter_pt]<<"; "<<pnt_counter[counter_pt]<<"\n";
          counter_pt++;
        }
    }

}

void getLines::set_short_Lines(long alti_num[], double altitude[], double longitude_s[], double latitude_s[], double longitude_e[], double latitude_e[])
{
       long counter1=0, counter2=0, lin_counter=0;

     for(counter1=0;counter1<num_points;counter1++)
     {
      if(lin_p[counter1]==lin_p[counter1+1])
      {
       for (counter2=0;counter2<num_lin;counter2++)
       {
          if(z[counter1]==alti_number[counter2])
          {
           alti_num[lin_counter]=counter2;
           altitude[lin_counter]=z[counter1];
           longitude_s[lin_counter]=x[counter1];
           latitude_s[lin_counter]=y[counter1];
           longitude_e[lin_counter]=x[counter1+1];
           latitude_e[lin_counter]=y[counter1+1];
           lin_counter++;
           }
       }
      }
     }
     
}

long getLines::getNumberLines()
{
     long counter1=0, counter2=0, counter_altitudes=0, counter_altitudes_temp=0, min=0;
     double temp=0.0;
     
     for(counter1=0;counter1<num_points;counter1++)
     {
      if (z[counter1]!=z[counter1-1])
      {
       counter_altitudes_temp++;
      }
     }
     double *altitude_temp = new double[counter_altitudes_temp];
     double *altitude = new double[counter_altitudes_temp];
     
     for(counter1=0;counter1<counter_altitudes_temp;counter1++)
     {
      altitude_temp[counter1]=-1;
      altitude[counter1]=-1;
     }
     
     counter_altitudes_temp=0;
     altitude_temp[0]=z[0];
     
     for(counter1=0;counter1<num_points;counter1++)
     {
       if (z[counter1]!=z[counter1-1])
       {
        altitude_temp[counter_altitudes_temp]=z[counter1];
        counter_altitudes_temp++;
       }
     }

// Sort altitudes  
     counter_altitudes=0;
     
     for(counter1=0;counter1<counter_altitudes_temp;counter1++)
     {
      min=counter1;
      for(counter2=counter1+1;counter2<counter_altitudes_temp;counter2++)
      {
       if (altitude_temp[counter2]< altitude_temp[min])
       {
        min=counter2;
       }
      }
      temp = altitude_temp[min];
      altitude_temp[min]=altitude_temp[counter1];
      altitude_temp[counter1]=temp;
     }

// Count altitudes

     counter2=0;
     for(counter1=0;counter1<counter_altitudes_temp;counter1++)
     {
      if(altitude_temp[counter1]!=altitude_temp[counter1+1])
      {
       altitude[counter2]=altitude_temp[counter1];
       counter2++;
      }
     }
     num_lin = counter2;
     
     alti_number = new double[num_lin];
     
     for (counter1=0;counter1<num_lin;counter1++)
     {
         alti_number[counter1]=altitude[counter1];
     }

     return num_lin;
     
}

double getLines::getAltiDistance()
{
     long counter1=0, counter2=0, counter_altitudes=0, counter_altitudes_temp=0, min=0;
     double temp=0.0, alti_dist1;

     for(counter1=0;counter1<num_points;counter1++)
     {
      if (z[counter1]!=z[counter1-1])
      {
       counter_altitudes_temp++;
      }
     }
     double *altitude_temp = new double[counter_altitudes_temp];
     double *altitude = new double[counter_altitudes_temp];

     for(counter1=0;counter1<counter_altitudes_temp;counter1++)
     {
      altitude_temp[counter1]=-1;
      altitude[counter1]=-1;
     }

     counter_altitudes_temp=0;
     altitude_temp[0]=z[0];

     for(counter1=0;counter1<num_points;counter1++)
     {
       if (z[counter1]!=z[counter1-1])
       {
        altitude_temp[counter_altitudes_temp]=z[counter1];
        counter_altitudes_temp++;
       }
     }

// Sort altitudes
     counter_altitudes=0;

     for(counter1=0;counter1<counter_altitudes_temp;counter1++)
     {
      min=counter1;
      for(counter2=counter1+1;counter2<counter_altitudes_temp;counter2++)
      {
       if (altitude_temp[counter2]< altitude_temp[min])
       {
        min=counter2;
       }
      }
      temp = altitude_temp[min];
      altitude_temp[min]=altitude_temp[counter1];
      altitude_temp[counter1]=temp;
     }

// Count altitudes

     counter2=0;
     for(counter1=0;counter1<counter_altitudes_temp;counter1++)
     {
      if(altitude_temp[counter1]!=altitude_temp[counter1+1])
      {
       altitude[counter2]=altitude_temp[counter1];
       counter2++;
      }
     }
     num_lin = counter2;

     alti_number = new double[num_lin];

     for (counter1=0;counter1<num_lin;counter1++)
     {
         alti_number[counter1]=altitude[counter1];
     }
     alti_dist1=((altitude[1]-altitude[num_lin])/num_lin);
//     cout<<"Abstand= "<<(altitude[1]-altitude[num_lin])/num_lin<<endl;
     return alti_dist1;

}

long getLines::getNumberParts()
{
     long counter1=0, lin_counter=0;
     
     for(counter1=0;counter1<num_points;counter1++)
     {
      if(lin_p[counter1]==lin_p[counter1+1])
      {
       lin_counter++;
      }
     }
     num_parts = lin_counter;
     
     return num_parts;
}

long getLines::getNumberPoints()
{     
     char *temp;
     num_points = 0;
     long counter=0;
     
     const char *total_chars=file_content.c_str();
     temp = (char*)total_chars;
     
     while (*total_chars)
     {
           if (*total_chars == '\n'){counter++;}
           total_chars++;
     }
     
     num_points = counter-1;
     cout<<num_points<<"\n";

     x = new double[num_points];
     y = new double[num_points];
     z = new double[num_points];
     lin_p = new long[num_points];
     pnt_counter = new long[num_points];
}

long getLines::getNumberPoints_bna()
{     
     char *temp;
     num_points = 0;
     long counter=0;
     long counter_lines=0;
     numLines_bna=0;
     
     const char *total_chars=file_content.c_str();
     temp = (char*)total_chars;
     
     while (*total_chars)
     {
           if (*total_chars == '\n'){counter++;}
           total_chars++;
           if (*total_chars == '"') {counter_lines++;}
     }
     
     num_points = counter-1-((counter_lines+1)/4);
     numLines_bna = (counter_lines+1)/4;

     x = new double[num_points];
     y = new double[num_points];
     z = new double[num_points];
     lin_p = new long[num_points];
     pnt_counter = new long[num_points];
     
     return num_points;
}

double getLines::getMaxX()
{
    return maxX;
}

double getLines::getMaxY()
{
    return maxY;
}

double getLines::getMinX()
{
    return minX;
}

double getLines::getMinY()
{
    return minY;
}

void getLines::findBoundaries()
{
    long counter=0;
    for (counter=0; counter<num_points;counter++)
    {
          if (x[counter]>maxX) {maxX=x[counter];}
          else {maxX=maxX;}
          
          if (y[counter]>maxY) {maxY=y[counter];}
          else {maxY=maxY;}
          
          if (x[counter]<minX && x[counter]>0.1) {minX=x[counter];}
          else {minX=minX;}
          
          if (y[counter]<minY && y[counter]>0.1) {minY=y[counter];}
          else {minY=minY;}
    }
}
//         string file_content;
//         char *file_name;  
//         long num_lin;
//         long num_parts;
//         long num_points;
//         double *x;
//         double *y;
//         double *z;
//         long *lin_p;
//         long *pnt_counter;
//         double *alti_number;
