//This program code is released under GNU General Public License (GPL)
//(http://www.gnu.org/copyleft/gpl.html)
//(C) Wolfgang Gossel (2012)
// Muehlweg 49 
// D-06114 Halle
//or: Martin Luther University
//    Dept. Hydrogeology and Environmental Geology
//    V.-Seckendorff Platz 3
//    D-06120 Halle
//email: wolfgang.gossel@geo.uni-halle.de
//homepage: http://www.mo2geo.org
//
#include <iostream>
#include <string>
#include <cmath>
#include "select_attribute_points.h"

using namespace std;

void sel_attrib_points::setRaster(double raster_lon[], double raster_lat[], long num_pnt_ras)
{
     long counter=0;
     num_p_ras = num_pnt_ras;
     x_ras = new double[num_pnt_ras];
     y_ras = new double[num_pnt_ras];
     z_ras = new double[num_pnt_ras];
     
     
     for(counter=0;counter<num_pnt_ras;counter++)
     {
      x_ras[counter]=raster_lon[counter];
      y_ras[counter]=raster_lat[counter];
     }
}

void sel_attrib_points::setLineSegments(long num_parts, long alti_num[], double altitude[], double longitude_s[], double latitude_s[], double longitude_e[], double latitude_e[], double alti_dist)
{
     long counter;
     num_l_parts = num_parts;
     distance_heights=alti_dist;
     lin_p = new long[num_parts];
     x_start=new double[num_parts];
     y_start=new double[num_parts];
     x_end=new double[num_parts];
     y_end=new double[num_parts];
     z=new double[num_parts];
     
     for(counter=0; counter<num_parts;counter++)
     {
      lin_p[counter]=alti_num[counter];
      x_start[counter]=longitude_s[counter];
      y_start[counter]=latitude_s[counter];
      x_end[counter]=longitude_e[counter];
      y_end[counter]=latitude_e[counter];
      z[counter]=altitude[counter];
     }
     
}

void sel_attrib_points::sortHeight()
{
     long counter;
     for(counter=0;counter<num_l_parts;counter++)
     {
      
     }
}

void sel_attrib_points::setBuffer(double distance)
{
     buff = distance/2;

}

void sel_attrib_points::quicksort_distances(double a[], long b[], long l, long r)
{		
    if(r>l)
    {
        long i=l-1, j=r, tmp, tmp2;	
        for(;;)
	{
            while(a[++i]<a[r]);
            while(a[--j]>a[r] && j>i);
            if(i>=j) break;
            tmp=a[i]; a[i]=a[j]; a[j]=tmp;
	    tmp2=b[i]; b[i]=b[j]; b[j]=tmp2;
        }
        tmp=a[i]; a[i]=a[r]; a[r]=tmp;
	tmp2=b[i]; b[i]=b[j]; b[j]=tmp2;

        quicksort_distances(a, b, l, i-1);
        quicksort_distances(a, b, i+1, r);
    }
}

void sel_attrib_points::select_and_set()
{
  long tmp_index2;
  long tmp_index;
  double distx_start=0, disty_start=0, distx_end=0, disty_end=0, dist_rp_enode, dist_rp_snode;
  
  long ct_buff;
  long ct_lin;
  long ct2_lin;
  long ct_ras_points;
  long temp1;
  long temp_buf_t;
  long number_of_altitude;
  long max_number_of_altitude;
  long factor_buf;
  long buff_crit;
  int done=0, done2=0;
  double dist_pnt_start;
  double dist_pnt_end;
  double xdiff_node_rp; //x-difference between node and raster point
  double ydiff_node_rp; //y-difference between node and raster point
  double alpha; //angle between line and distance from node to raster point
  double dist_line_rp; //distance between line and raster point
  double u_sqr;//direction-vector squared
  double x_start_cc_sqr;//difference vector Line start - center of circle squared
  double a;//help variable
  double b;//help variable
  double c;//help variable
  double d;//help variable
  double f;//help variable
  long hsi, hsir, hsj, hsl; //help variables for heapsort
  double hsrra, hsrra2;//help variable for heapsort
  double h;//distance of intersection circle-line from the end of a line
  double xi;//coordinate of intersection point circle-line
  double yi;//coordinate of intersection point circle-line
  long e;//help variable
  double buff_dist;
  double xdiff_line;
  double ydiff_line;
  double h1;
  double h2;
  int *has_value = new int[num_p_ras];
  int *buf_1 = new int[num_p_ras];
  double *z_1 = new double[num_p_ras];
  double *bufferzwei = new double[num_p_ras];
  int *buf_2 = new int[num_p_ras];
  double *z_2 = new double[num_p_ras];
  double *z_ges = new double[num_p_ras];

  
  long num_sel_lin;
  unsigned long num_sel_lin_all;
  unsigned long ct_num_sel_lin;
  
  
  for (e=0;e<num_l_parts;e++)
  {
   buf_1[e]=0;
   buf_2[e]=0;
   has_value[e]=0;
   z_1[e]=0;
   z_2[e]=0;
   z_ges[e]=0;
  }


  //buff=25;
  max_number_of_altitude=1000;//lin_p[num_l_parts-1];
  num_sel_lin=250;
  num_sel_lin_all=num_sel_lin*num_p_ras;
  
  
     long *indeces_200_nearest_lin_rp = new long[num_sel_lin_all];
     double *x_start_sel = new double[num_sel_lin_all];
     double *y_start_sel = new double[num_sel_lin_all];
     double *x_end_sel = new double[num_sel_lin_all];
     double *y_end_sel = new double[num_sel_lin_all];
     double *z_lin_sel = new double[num_sel_lin_all];
     double *dist_lin_sel = new double[num_sel_lin_all];
     double dist_rp_node;
     long index_rp_node;

  ct_lin=0;
  factor_buf=0;
  
#pragma omp parallel
{//pragmao
#pragma omp for private (hsi, hsj, hsir, x_start_sel, y_start_sel, x_end_sel, y_end_sel, z_lin_sel, dist_lin_sel, num_sel_lin_all, num_sel_lin, ct_num_sel_lin, \
  distx_start, disty_start, distx_end, disty_end, dist_rp_snode, dist_rp_enode, tmp_index, dist_rp_node, index_rp_node, \
  ct_ras_points,e,number_of_altitude, ct_lin, ct2_lin, buff_dist, xdiff_node_rp, ydiff_node_rp, \
  u_sqr, x_start_cc_sqr, a, b, f, c, d, xi, yi, xdiff_line, ydiff_line, h1, h2)
  
//select lines within certain distance to each raster point according to starting points and end points (nodes) of short lines

for (ct_ras_points=0;ct_ras_points<num_p_ras;ct_ras_points++)
{


    for(ct_lin=0; ct_lin<num_l_parts;ct_lin++)
    {
      distx_start=x_start[ct_lin]-x_ras[ct_ras_points];
      disty_start=y_start[ct_lin]-y_ras[ct_ras_points];
      distx_start=distx_start*distx_start;
      disty_start=disty_start*disty_start;
      dist_rp_snode=sqrt(distx_start+disty_start);
      
      distx_end=x_end[ct_lin]-x_ras[ct_ras_points];
      disty_end=y_end[ct_lin]-y_ras[ct_ras_points];
      distx_end=distx_end*distx_end;
      disty_end=disty_end*disty_end;
      dist_rp_enode=sqrt(distx_end+disty_end);    
      
      if(dist_rp_snode>dist_rp_enode) 
      {
	dist_rp_node=dist_rp_enode; 
	index_rp_node=ct_lin;
      }
      
      else 
      {
	dist_rp_node=dist_rp_snode; 
	index_rp_node=ct_lin;
      }
      
      a=dist_rp_node;
      hsir=index_rp_node;
      hsi=ct_lin-1;
      while(hsi>0 && dist_rp_node[hsi]>a)
      {
	dist_rp_node[hsi+1]=dist_rp_node[hsi];
	index_rp_node[hsi+1]=index_rp_node[hsi];
	hsi--;
      }
      dist_rp_node[hsi+1]=a;
      index_rp_node[hsi+1]=hsir;
      
      tmp_index=index_rp_node;
      x_start_sel[ct_ras_points*num_sel_lin+ct_lin]=x_start[tmp_index];
      y_start_sel[ct_ras_points*num_sel_lin+ct_lin]=y_start[tmp_index];
      x_end_sel[ct_ras_points*num_sel_lin+ct_lin]=x_end[tmp_index];
      y_end_sel[ct_ras_points*num_sel_lin+ct_lin]=y_end[tmp_index];
      z_lin_sel[ct_ras_points*num_sel_lin+ct_lin]=z[tmp_index];
        
    }

//sort the lines according to distances, but save the indices; algorithm: quicksort
      
//  quicksort_distances(dist_rp_node, index_rp_node, 1, num_l_parts);
//substitute quicksort by slowsort in OpenMP-version

//save sorted values in an extra array

 for(e=0;e<200;e++)//f3o
 {
 buff_dist=(e+1)*buff;
 for(number_of_altitude=0;number_of_altitude<max_number_of_altitude;number_of_altitude++)//f1o
 {
     for(ct_lin=0;ct_lin<num_sel_lin;ct_lin++)//f2o
     {         
         
         if(lin_p[ct_lin]==number_of_altitude)//ii1o
         {
           if (has_value[ct_ras_points]<1)//ii2o
           {
           xdiff_node_rp=x_start_sel[ct_lin]-x_ras[ct_ras_points];
           ydiff_node_rp=y_start_sel[ct_lin]-y_ras[ct_ras_points];

            u_sqr=((x_end_sel[ct_lin]-x_start_sel[ct_lin])*(x_end_sel[ct_lin]-x_start_sel[ct_lin]))+((y_end_sel[ct_lin]-y_start_sel[ct_lin])*(y_end_sel[ct_lin]-y_start_sel[ct_lin]));
            x_start_cc_sqr =(xdiff_node_rp*xdiff_node_rp)+(ydiff_node_rp*ydiff_node_rp);
            a=u_sqr*(x_start_cc_sqr-(buff_dist*buff_dist));
            b=((x_end_sel[ct_lin]-x_start_sel[ct_lin])*(x_start_sel[ct_lin]-x_ras[ct_ras_points]))+((y_end_sel[ct_lin]-y_start_sel[ct_lin])*(y_start_sel[ct_lin]-y_ras[ct_ras_points]));
            f=b*b;
            if (f>a)//ii4o
            {
             c=(-b+sqrt(f-a))/u_sqr;
             d=(-b-sqrt(f-a))/u_sqr;
             if (((c>0)&&(c<1))||((d>0)&&(d<1)))  //ii5o
             {
              buf_1[ct_ras_points]=e+1;
              z_1[ct_ras_points]=z_lin_sel[ct_lin];
              has_value[ct_ras_points]=1;
	      
              //break;
             }//ii5c
            }//ii4c
           }//ii2c
         }//ii1c
       }//f2c
     }//f1c
  }//f3c
  

 for(e=0;e<300;e++)//f3o
 {
 buff_dist=(e+1)*buff;
 for(number_of_altitude=0;number_of_altitude<max_number_of_altitude;number_of_altitude++)//f1o
 {
     for(ct_lin=0;ct_lin<num_sel_lin;ct_lin++)//f2o
     {              
         if(lin_p[ct_lin]==number_of_altitude && z_1[ct_ras_points]!= z_lin_sel[ct_lin])//ii1o
         {
           if (has_value[ct_ras_points]<2) //ii2o
           {
           xdiff_node_rp=x_start_sel[ct_lin]-x_ras[ct_ras_points];
           ydiff_node_rp=y_start_sel[ct_lin]-y_ras[ct_ras_points];
	   
            u_sqr=((x_end_sel[ct_lin]-x_start_sel[ct_lin])*(x_end_sel[ct_lin]-x_start_sel[ct_lin]))+((y_end_sel[ct_lin]-y_start_sel[ct_lin])*(y_end_sel[ct_lin]-y_start_sel[ct_lin]));
            x_start_cc_sqr =(xdiff_node_rp*xdiff_node_rp)+(ydiff_node_rp*ydiff_node_rp);
            a=u_sqr*(x_start_cc_sqr-(buff_dist*buff_dist));
            b=((x_end_sel[ct_lin]-x_start_sel[ct_lin])*(x_start_sel[ct_lin]-x_ras[ct_ras_points]))+((y_end_sel[ct_lin]-y_start_sel[ct_lin])*(y_start_sel[ct_lin]-y_ras[ct_ras_points]));
            f=b*b;
            if (f>a)//ii4o
            {
             c=(-b+sqrt(f-a))/u_sqr;
             d=(-b-sqrt(f-a))/u_sqr;
             if (((c>0)&&(c<1))||((d>0)&&(d<1)))  //ii5o
             {
                if ((c>0)&&(c<1)){h=c;}
                if ((d>0)&&(d<1)){h=d;}
                xi=x_start_sel[ct_lin]+((x_end_sel[ct_lin]-x_start_sel[ct_lin])*h);
                yi=y_start_sel[ct_lin]+((y_end_sel[ct_lin]-y_start_sel[ct_lin])*h);

              for(ct2_lin=0;ct2_lin<num_sel_lin;ct2_lin++)//f4o
              {
                if (z_lin_sel[ct2_lin]==z_1[ct_ras_points])//ii6o
                {
                xdiff_node_rp=x_start_sel[ct2_lin]-x_ras[ct_ras_points];
                ydiff_node_rp=y_start_sel[ct2_lin]-y_ras[ct_ras_points];
                xdiff_line=x_end_sel[ct2_lin]-x_start_sel[ct2_lin];
                ydiff_line=y_end_sel[ct2_lin]-y_start_sel[ct2_lin];
                h1=((xdiff_node_rp*ydiff_line)-(ydiff_node_rp*xdiff_line))/(((xi-x_ras[ct_ras_points])*ydiff_line)-((yi-y_ras[ct_ras_points])*xdiff_line));
                h2=((h1*yi)-(h1*y_ras[ct_ras_points])-ydiff_node_rp)/(ydiff_line);
                
                if((h1>0 && h1<1) && (h2>0 && h2<1))//ii7o
                {
                    has_value[ct_ras_points]=3;
                    if (z_lin_sel[ct_lin]<z_1[ct_ras_points])//ii8o
                    {
                        z_2[ct_ras_points]=z_1[ct_ras_points]+(z_1[ct_ras_points]-z_lin_sel[ct_lin]);
                        buf_2[ct_ras_points]=e+1;
                        z_ges[ct_ras_points]=((z_2[ct_ras_points]*buf_1[ct_ras_points])+(z_1[ct_ras_points]*buf_2[ct_ras_points]))/(buf_1[ct_ras_points]+buf_2[ct_ras_points]);
                        //break;
                    } //ii8c
                    else  //ie8o
                    {
                        z_2[ct_ras_points]=z_1[ct_ras_points]-(z_lin_sel[ct_lin]-z_1[ct_ras_points]);
                        buf_2[ct_ras_points]=e+1;
                        z_ges[ct_ras_points]=((z_2[ct_ras_points]*buf_1[ct_ras_points])+(z_1[ct_ras_points]*buf_2[ct_ras_points]))/(buf_1[ct_ras_points]+buf_2[ct_ras_points]);
                        //break;
                    } //ie8c


                }//ii7c
                else if (has_value[ct_ras_points]<3)//ie7o
                {
                    z_2[ct_ras_points]=z_lin_sel[ct_lin];
                    buf_2[ct_ras_points]=e+1;
                    z_ges[ct_ras_points]=((z_2[ct_ras_points]*buf_1[ct_ras_points])+(z_1[ct_ras_points]*buf_2[ct_ras_points]))/(buf_1[ct_ras_points]+buf_2[ct_ras_points]);
                    has_value[ct_ras_points]=2;
                    //break;
                }//ie7c
                }//ii6c
              }//f4c
              
             }//ii5c
            }//ii4c
           } //ii2c
}//ii1c
}//f2c
}//f1c
}//f3c
cout<<x_ras[ct_ras_points]<<","<<y_ras[ct_ras_points]<<","<<buf_1[ct_ras_points]<<","<<z_1[ct_ras_points]<<","<<has_value[ct_ras_points]<<","<<buf_2[ct_ras_points]<<","<<z_2[ct_ras_points]<<","<<z_ges[ct_ras_points]<<endl;
z_ras[ct_ras_points]=z_ges[ct_ras_points];

}//pragmac

    
  }

}

void sel_attrib_points::getRaster()//double raster_lon[], double raster_lat[], long num_pnt_ras, double raster_z[])
{
    double nrows=0, ncols=0, xmin=0, ymin=0, xmax=0, ymax=0, zmin=99999, zmax=0, dist_ras=0;
    long counter_ras=0;
    xmin=x_ras[0];
    ymin=y_ras[0];
    xmax=x_ras[num_p_ras-1];
    ymax=y_ras[num_p_ras-1];
    
    dist_ras=buff*2;
    nrows=(ymax-ymin)/dist_ras;
    ncols=(xmax-xmin)/dist_ras;
    nrows=nrows+1;
    ncols=ncols+1;
    
    for(long counter=0;counter<num_p_ras;counter++)
    {
        if(z_ras[counter]<zmin)
        {
            zmin=z_ras[counter];
        }
        else {zmin=zmin;}
        if(z_ras[counter]>zmax)
        {
            zmax=z_ras[counter];
        }
        else {zmax=zmax;}
    }
    
    cout<<"DSAA\n";
    cout<<ncols<<" "<<nrows<<"\n";
    cout<<xmin<<" "<<xmax<<"\n";
    cout<<ymin<<" "<<ymax<<"\n";
    cout<<zmin<<" "<<zmax<<"\n";
    
    for(long counter_rows=0; counter_rows<nrows; counter_rows++)
    {
        for(long counter_cols=0; counter_cols<ncols; counter_cols++)
        {
            counter_ras=counter_rows*ncols+counter_cols;
            cout<<z_ras[counter_ras]<<" ";
        }
        cout<<"\n";
    }
    
}
                  
//long num_parts;
//double *x_start;
//double *y_start;
//double *x_end;
//double *y_end;
//double *z;
//long *lin_p;
//long num_pnt_ras;
//double *x_ras;
//double *y_ras;
//double *z_ras;
//double buff;
